#!/usr/bin/perl -w
=head1 Name
    /public/agis/wuzhiqiang_group/liaoxuezhu/07.Dalbergia_renew/01.full.len.tree/Dalbergia/manual/find.snp/find.snp.pl
Info
    Version V
    Author: liaoxuezhu,1113monian@live.cn
    Created Time: 2020-07-10 01:41:39
    Created Version: find.snp.pl
Usage
    perl find.snp.pl alignment_file species_file
=cut

use strict;
use List::MoreUtils qw(uniq);

my $file = shift;
my $id_lst = shift;

my (@id_list,$id_list,$id,$seq,@total_list,$total_list,%hash,$hash,%hash1,$hash1);
open FILE, $file || die $!;
while (<FILE>) {
	if (/\>/) {
		$id = $_;
		chomp $id;
		$id =~ s/\>//g;
		$seq = <FILE>;
		chomp $seq;
		push @total_list, $id;
		$hash{$id} = $seq;
	}
}
close FILE;

open LST, $id_lst|| die $!;
while (<LST>) {
	chomp $_;
	$hash1{$_} = 1;
	push @id_list, $_;
}

my (@other, $other);
foreach $total_list (@total_list) {
	if (exists $hash1{$total_list}) {
	} else {
		push @other, $total_list;
	}
}

my $len = length($hash{$total_list[0]});
print "$len\n";
print "Site\tNt\tNt_other\n";
my ($nt,@nt_a,$nt_a,@nt_a_uniq,$nt_a_uniq,$len_nt_a_uniq,$nt_o,@nt_o_a,$nt_o_a,@nt_o_a_uniq,$nt_o_a_uniq,$len_nt_o_a_uniq);
for my $i (0..$len-1) {
	undef @nt_a;
	foreach $id_list (@id_list) {
		$nt = substr($hash{$id_list},$i,1);
		push @nt_a, $nt;
	}
	@nt_a_uniq = uniq@nt_a;
	$len_nt_a_uniq = @nt_a_uniq;
	if ($len_nt_a_uniq == 1) {
		undef @nt_o_a;
		foreach $other (@other) {
			$nt_o = substr($hash{$other},$i,1);
			push @nt_o_a, $nt_o;
		}
		@nt_o_a_uniq = uniq@nt_o_a;
		$len_nt_o_a_uniq = @nt_o_a_uniq;
		if ($len_nt_o_a_uniq == 1) {
			if ($nt_o_a_uniq[0] eq $nt_a_uniq[0]) {
			} else {
				my $site = $i + 1;
				print "$site\t$nt_a_uniq[0]\t$nt_o_a_uniq[0]\n";
			}
		}
	}
}
